Wt: Wt::WAbstractItemDelegate Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions
Wt::WAbstractItemDelegate Class Reference
Model/view system

Abstract delegate class for rendering an item in an item view. More...

`#include <Wt/WAbstractItemDelegate>`

Inheritance diagram for Wt::WAbstractItemDelegate:
[legend]

List of all members.

## Public Member Functions
| WAbstractItemDelegate (WObject *parent=0)
| Constructor.
virtual | ~WAbstractItemDelegate ()
| Destructor.
virtual WWidget * | update (WWidget *widget, const WModelIndex &index, WFlags< ViewItemRenderFlag > flags)=0
| Creates or updates a widget that renders an item.
virtual void | updateModelIndex (WWidget *widget, const WModelIndex &index)
| Updates the model index of a widget.
virtual boost::any | editState (WWidget *widget) const
| Returns the current edit state.
virtual void | setEditState (WWidget *widget, const boost::any &value) const
| Sets the editor data from the editor state.
virtual WValidator::State | validate (const WModelIndex &index, const boost::any &editState) const
| Returns whether the edited value is valid.
virtual void | setModelData (const boost::any &editState, WAbstractItemModel *model, const WModelIndex &index) const
| Saves the edited data to the model.
Signal< WWidget *, bool > & | closeEditor ()
| Signal which indicates that an editor needs to be closed.
const Signal< WWidget *, bool > & | closeEditor () const
| Signal which indicates that an editor needs to be closed.

## Detailed Description

Abstract delegate class for rendering an item in an item view.

Rendering of an item in a WAbstractItemView is delegated to an implementation of this delegate class. The default implementation used by Wt's item views is WItemDelegate. To provide specialized rendering support, you can reimplement this class (or specialize WItemDelegate).

As a delegate is used for rendering multiple items, the class should not keep state about one specific item.

A delegate may provide editing support by instantiating an editor when update() is called with the Wt::RenderEditing flag. In that case, you will also need to implement editState() and setEditState() to support virtual scrolling and setModelData() to save the edited value to the model. For an example, see the WItemDelegate.

See also:
  WAbstractItemView::setItemDelegateForColumn()

## Member Function Documentation

Signal<WWidget *, bool>& Wt::WAbstractItemDelegate::closeEditor | ( |  | ) |

Signal which indicates that an editor needs to be closed.

The delegate should emit this signal when it decides for itself that it should be closed (e.g. because the user confirmed the edited value or cancelled the editing). The View will then rerender the item if needed.

The second boolean argument passed to the signal is a flag which indicates whether the editor feels that the value should be saved or cancelled.

See also:
  WAbstractItemView::closeEditor()

const Signal<WWidget *, bool>& Wt::WAbstractItemDelegate::closeEditor | ( |  | ) | const

Signal which indicates that an editor needs to be closed.

See also:
  closeEditor()

boost::any Wt::WAbstractItemDelegate::editState | ( | WWidget * | widget | ) | const`[virtual]`

Returns the current edit state.

Because a View may support virtual scrolling in combination with editing, it may happen that the view decides to delete the editor widget while the user is editing. To allow to reconstruct the editor in its original state, the View will therefore ask for the editor to serialize its state in a boost::any.

When the view decides to close an editor and save its value back to the model, he will first call editState() and then setModelData().

The default implementation assumes a read-only delegate, and returns a boost::any().

See also:
  setEditState(), setModelData()

Reimplemented in Wt::WItemDelegate.

void Wt::WAbstractItemDelegate::setEditState | ( | WWidget * | widget,
|  | const boost::any & | value
| ) |  | const`[virtual]`

Sets the editor data from the editor state.

When the View scrolls back into view an item that was being edited, he will use setEditState() to allow the editor to restore its current editor state.

The default implementation assumes a read-only delegate and does nothing.

See also:
  editState()

Reimplemented in Wt::WItemDelegate.

void Wt::WAbstractItemDelegate::setModelData | ( | const boost::any & | editState,
|  | WAbstractItemModel * | model,
|  | const WModelIndex & | index
| ) |  | const`[virtual]`

Saves the edited data to the model.

The View will use this method to save the edited value to the model. The `editState` is first fetched from the editor using editState().

The default implementation assumes a read-only delegate does nothing.

Reimplemented in Wt::WItemDelegate.

virtual WWidget* Wt::WAbstractItemDelegate::update | ( | WWidget * | widget,
|  | const WModelIndex & | index,
|  | WFlags< ViewItemRenderFlag > | flags
| ) |  | `[pure virtual]`

Creates or updates a widget that renders an item.

The item is specified by its model `index`, which also indicates the model. If an existing widget already renders the item, but needs to be updated, it is passed as the `widget` parameter. You may decide to create a new widget, in which case you are responsible to delete the previous `widget` if it is not reused.

When `widget` is `0`, a new widget needs to be created.

The returned widget should be a widget that responds properly to be given a height, width and style class. In practice, that means it cannot have a border or margin, and thus cannot be a WFormWidget since those widgets typically have built-in borders and margins. If you want to return a form widget (for editing the item), you should wrap it in a container widget.

The `flags` parameter indicates options for rendering the item.

Implemented in Wt::WItemDelegate.

void Wt::WAbstractItemDelegate::updateModelIndex | ( | WWidget * | widget,
|  | const WModelIndex & | index
| ) |  | `[virtual]`

Updates the model index of a widget.

This method is invoked by the view when due to row/column insertions or removals, the index has shifted.

You should reimplement this method only if you are storing the model index in the `widget`, to update the stored model index.

The default implementation does nothing.

Reimplemented in Wt::WItemDelegate.

WValidator::State Wt::WAbstractItemDelegate::validate | ( | const WModelIndex & | index,
|  | const boost::any & | editState
| ) |  | const`[virtual]`

Returns whether the edited value is valid.

The default implementation does nothing and returns Valid.

See also:
  WValidator::validate()

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator